<?php

/* E-Mail-Verschleierer2
 *  verschleiert die E-Mail-Adresse per JavaScript-Code
 *  erzeugt _keine_ anklickbare E-Mail-Links
 *  Nach einer Idee von Tim Williams, University of Arizona und Andrew Moulden, Site Engineering Ltd
 *  Mehr Infos gibt es unter http://www.jottings.com/obfuscator/ [Quelltext ansehen]
 *
  * Kurzfassung: 
  * - Es wird ein verwürfeltes Alphabet erzeugt und 
  * - darauf ein Verschiebealgorithmus angewendet [Verschiebung um 'shift', der Länge der E-Mail-Adresse],
  * - der mit JavaScript wieder rückgangig gemacht wird
 * eingebunden: 2015-06-05
 */

//defined('CMBASIC') or die();
mt_srand(time()); //'Seed' für Zufallsgenerator mit der Zahl der Sekunden seit 1.1.1970 setzen, einmal pro Skriptaufruf 
function zufall($zahl) {
 return mt_rand(0,$zahl-1);
}

// Alles, was wie eine E-Mail-Adresse aussieht, wird herausgefiltert. 
preg_match_all("|([a-zA-Z0-9-_]+(\.[a-zA-Z0-9-_]*)*@([a-zA-Z0-9-_]+\.)+[a-zA-Z]{2,4})|i", $acticon, $mailfund);

// Jeder Fund wird einzeln behandelt und ersetzt.
foreach ($mailfund[1] as $adresse) {
  // Die Adresse wird nicht zerlegt, sondern als ganzes behandelt.
  $inarbeit = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.-_@"; /* noch ist das Alphabet geordnet */
  $mixedkey=""; /* hier landet das Ergebnis */
  while (strlen($inarbeit) > 0) {
  	/*	Das durch die 'ranpos' gewählte Zeichen wird aus 'inarbeit' herausgenommen
  		und an mixedkey angehängt, so werden die Zeichen 'verwürfelt', ohne das eines verloren geht */
  	$ranpos = zufall(strlen($inarbeit)); /* Position des nächsten gewählten Zeichens */
  	$nextchar = $inarbeit[$ranpos]; /* gewähltes Zeichen an der Zufallsstelle merken */
  	$mixedkey .= $nextchar; /* Zeichen anhängen */
  	/* Das gewählte Zeichen aus dem String $inarbeit herauspulen */
  	$inarbeit = str_replace ($nextchar,'',$inarbeit);
  }
  $cipher = $mixedkey;
  $codiert = "";
  $shift = strlen($adresse);
  $cipher_len = strlen($cipher);
  /* hier wird 'codiert' zusammengesetzt */
     for ($j=0; $j<strlen($adresse); $j++) {
  	if (strpos($cipher,$adresse[$j])===false) {
  		$codiert .= $adresse[$j];
  	}
  	else {
  		$chr = (strpos($cipher,$adresse[$j]) + $shift) % $cipher_len;
  		$codiert .= $cipher[$chr];
  	}
     }
  
  // Jetzt kommt der interessante Teil - JavaScript zum entschlüsseln
  // Wer Lust hat, kann die Variablen noch auf die Länge 1 kürzen: 
  // codiert -> c, key -> k, shift -> s, link -> l, zn -> z
  $verschleiern  = <<<VERSCHLEIERN
  <script type="text/javascript">
  <!--
  { codiert = '$codiert'
    key = '$cipher'
    shift=codiert.length
    link=''
    for (i=0; i<codiert.length; i++) {
      if (key.indexOf(codiert.charAt(i))==-1) {
        link += codiert.charAt(i)
      }
      else {     
        zn = (key.indexOf(codiert.charAt(i))-shift+key.length) % key.length
        link += (key.charAt(zn))
      }
    }
    document.write('<a class=\'mailto\' href=\'ma'+'ilt'+'o:'+link+'\'>'+link+'</a>')
  }
  //-->
  </script>
  <span class='mailhinweis'><noscript>Bitte lassen Sie JavaScript zu, um die E-Mail-Adresse sehen zu können.</noscript></span>

VERSCHLEIERN;

  $muster = "|$adresse|";
  $acticon = preg_replace($muster, $verschleiern, $acticon);
}
?>